## jersey.repackaged.org.objectweb.asm
Class AnnotationVisitor

    java.lang.Object
      jersey.repackaged.org.objectweb.asm.AnnotationVisitor

    public abstract class AnnotationVisitor

extends java.lang.Object

A visitor to visit a Java annotation. The methods of this class must be called in the following order: ( `visit` | `visitEnum` | `visitAnnotation` | `visitArray` )* `visitEnd`.

Author:
  Eric Bruneton, Eugene Kuleshov

Field Summary
`protected int` | `api` The ASM API version implemented by this visitor.
`protected AnnotationVisitor` | `av` The annotation visitor to which this visitor must delegate method calls.

Constructor Summary
`AnnotationVisitor(int api)` Constructs a new `AnnotationVisitor`.
`AnnotationVisitor(int api, AnnotationVisitor av)` Constructs a new `AnnotationVisitor`.

Method Summary
`void` | `visit(java.lang.String name, java.lang.Object value)` Visits a primitive value of the annotation.
`AnnotationVisitor` | `visitAnnotation(java.lang.String name, java.lang.String desc)` Visits a nested annotation value of the annotation.
`AnnotationVisitor` | `visitArray(java.lang.String name)` Visits an array value of the annotation.
`void` | `visitEnd()` Visits the end of the annotation.
`void` | `visitEnum(java.lang.String name, java.lang.String desc, java.lang.String value)` Visits an enumeration value of the annotation.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### api

    protected final int api

  The ASM API version implemented by this visitor. The value of this field must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.

### av

    protected AnnotationVisitor av

  The annotation visitor to which this visitor must delegate method calls. May be null.

Constructor Detail

### AnnotationVisitor

    public AnnotationVisitor(int api)

  Constructs a new `AnnotationVisitor`.

  Parameters:
    `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.

### AnnotationVisitor

    public AnnotationVisitor(int api,
                             AnnotationVisitor av)

  Constructs a new `AnnotationVisitor`.

  Parameters:
    `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.
    `av` - the annotation visitor to which this visitor must delegate method calls. May be null.

Method Detail

### visit

    public void visit(java.lang.String name,
                      java.lang.Object value)

  Visits a primitive value of the annotation.

  Parameters:
    `name` - the value name.
    `value` - the actual value, whose type must be `Byte`, `Boolean`, `Character`, `Short`, `Integer` , `Long`, `Float`, `Double`, `String` or `Type` or OBJECT or ARRAY sort. This value can also be an array of byte, boolean, short, char, int, long, float or double values (this is equivalent to using `visitArray` and visiting each array element in turn, but is more convenient).

### visitEnum

    public void visitEnum(java.lang.String name,
                          java.lang.String desc,
                          java.lang.String value)

  Visits an enumeration value of the annotation.

  Parameters:
    `name` - the value name.
    `desc` - the class descriptor of the enumeration class.
    `value` - the actual enumeration value.

### visitAnnotation

    public AnnotationVisitor visitAnnotation(java.lang.String name,
                                             java.lang.String desc)

  Visits a nested annotation value of the annotation.

  Parameters:
    `name` - the value name.
    `desc` - the class descriptor of the nested annotation class.
  Returns:
    a visitor to visit the actual nested annotation value, or `null` if this visitor is not interested in visiting this nested annotation. The nested annotation value must be fully visited before calling other methods on this annotation visitor.

### visitArray

    public AnnotationVisitor visitArray(java.lang.String name)

  Visits an array value of the annotation. Note that arrays of primitive types (such as byte, boolean, short, char, int, long, float or double) can be passed as value to `visit`. This is what `ClassReader` does.

  Parameters:
    `name` - the value name.
  Returns:
    a visitor to visit the actual array value elements, or `null` if this visitor is not interested in visiting these values. The 'name' parameters passed to the methods of this visitor are ignored. All the array values must be visited before calling other methods on this annotation visitor.

### visitEnd

    public void visitEnd()

  Visits the end of the annotation.

Copyright © 2017 Oracle Corporation. All Rights Reserved.